commit:     c584d676c9834bc567c1452789235903b0988ec7
Author:     Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Fri Sep 25 09:46:01 2020 +0000
Commit:     Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Fri Sep 25 12:13:31 2020 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=c584d676

dev-python/pypy: Bump to 7.3.2 final

Signed-off-by: Michał Górny <mgorny <AT> gentoo.org>

 dev-python/pypy/Manifest          |   1 +
 dev-python/pypy/pypy-7.3.2.ebuild | 175 ++++++++++++++++++++++++++++++++++++++
 2 files changed, 176 insertions(+)

diff --git a/dev-python/pypy/Manifest b/dev-python/pypy/Manifest
index 6c73fdd1956..092d1b35447 100644
--- a/dev-python/pypy/Manifest
+++ b/dev-python/pypy/Manifest
@@ -1,4 +1,5 @@
 DIST pypy2.7-v7.3.1-src.tar.bz2 21053306 BLAKE2B 
071d59b7978c98e9ed9243d9a64d93d21b524351cb9a45e0f7d48828f919c84585a1164e7c38739fdd8828ab4b1eedade96dff7d64d0d9cbfe00c74d88d532bb
 SHA512 
1bec44fa0fc4b1186e25f69303f9e332df32184be990d86fba41c40152664a93bd65eabf4dded133371271402cea9b150b60c13bce89d1004b276f0908c0b8f1
+DIST pypy2.7-v7.3.2-src.tar.bz2 21142873 BLAKE2B 
e6bcd2dc28ef740962d053753ccd172e3895fc83fe23a319c003248e0986f9805839daddd13a0f480f1e9ee813979742699cb0bc8c42b6b05c193fedf67aea4f
 SHA512 
b40d93d615a27e3a035007307a8ab2b49ff90f3047af914b268a80feb8219d372eca14c04a8b0dea91efb992653457b7c6d088c784de32c414cc48879f2d15fc
 DIST pypy2.7-v7.3.2rc2-src.tar.bz2 21145693 BLAKE2B 
e722111435f81d00ecb5cec83e78e17676a042703fe83c049456fa6e5debdb1c09cc3f1fd71bcd8a8469da373a7c8131c252b3f139959a442f4cfa2b7f202c6f
 SHA512 
ba7cccdaff1616ad0090cb0942ad35eda025a758be4d6b4e978bce19fb8cb8840136297fb924127a7e99f02c09665bde7eaf714e1744b9b32612973355459ad4
 DIST python-gentoo-patches-2.7.17-r1.tar.xz 14708 BLAKE2B 
f6e25236a471649de122d0f29506f7a4f34044a568ead47a68980411d9722b761fe1f9d653d5edccb6978b65c8c1eecbef55f403b94f32b37c0ad68e061505a8
 SHA512 
ecdde5e38c6fe5e69691fb3a68c8f4f43da7857d4abaff763d3cf6ad864ba43c769c03b186b60f2736a1ffb1e3e4c9982715d1b8a99ff3f5740096153bb8a90f
 DIST python-gentoo-patches-2.7.18-r1.tar.xz 15500 BLAKE2B 
7008b29827dbbd80d4ab8f010ccf9efced99c6b4b9109e4430c0ba269ce53529cb6fedd832502c8d2d3aa21938749cc3591c2545b21c0a59a6e60f8598e84ccc
 SHA512 
e656ab07281fd932b92165674619bbf55ecf410d2937ae4ae771d490b4532540498cc731d30d19c1e8aafd1f64df8a406bbfbb46ea985b3dcd8edb89a0b7f20f

diff --git a/dev-python/pypy/pypy-7.3.2.ebuild 
b/dev-python/pypy/pypy-7.3.2.ebuild
new file mode 100644
index 00000000000..894219fffb4
--- /dev/null
+++ b/dev-python/pypy/pypy-7.3.2.ebuild
@@ -0,0 +1,175 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit pax-utils python-utils-r1
+
+MY_P=pypy2.7-v${PV/_/}
+# note: remember to update this to newest dev-lang/python:2.7 on bump
+PATCHSET="python-gentoo-patches-2.7.18-r1"
+
+DESCRIPTION="A fast, compliant alternative implementation of the Python 
language"
+HOMEPAGE="https://pypy.org/";
+SRC_URI="https://buildbot.pypy.org/pypy/${MY_P}-src.tar.bz2
+       https://dev.gentoo.org/~mgorny/dist/python/${PATCHSET}.tar.xz";
+S="${WORKDIR}/${MY_P}-src"
+
+LICENSE="MIT"
+# pypy -c 'import sysconfig; print sysconfig.get_config_var("SOABI")'
+SLOT="0/73"
+KEYWORDS="~amd64 ~ppc64 ~x86 ~amd64-linux ~x86-linux"
+IUSE="bzip2 gdbm +jit libressl ncurses sqlite tk"
+
+RDEPEND="
+       || (
+               dev-python/pypy-exe:${PV}[bzip2?,ncurses?]
+               dev-python/pypy-exe-bin:${PV}
+       )
+       !libressl? ( dev-libs/openssl:0= )
+       libressl? ( dev-libs/libressl:0= )
+       gdbm? ( sys-libs/gdbm:0= )
+       sqlite? ( dev-db/sqlite:3= )
+       tk? (
+               dev-lang/tk:0=
+               dev-tcltk/tix:0=
+       )
+       !<dev-python/pypy-bin-7.3.0:0"
+DEPEND="${RDEPEND}"
+
+src_prepare() {
+       eapply "${FILESDIR}/7.3.1-gentoo-path.patch"
+       eapply 
"${FILESDIR}/1.9-distutils.unixccompiler.UnixCCompiler.runtime_library_dir_option.patch"
+
+       sed -e "s^@EPREFIX@^${EPREFIX}^" \
+               -i lib-python/2.7/distutils/command/install.py || die
+
+       # apply CPython stdlib patches
+       pushd lib-python/2.7 > /dev/null || die
+       # TODO: cpy turkish locale patch now fixes C code
+       # probably needs better port to pypy, if it is broken there
+       eapply "${FILESDIR}"/5.8.0_all_distutils_cxx.patch
+       eapply -p2 "${WORKDIR}/${PATCHSET}"/0010-use_pyxml.patch
+       popd > /dev/null || die
+
+       # this test relies on pypy-c hardcoding correct build time paths
+       sed -i -e 's:test_executable_without_cwd:_&:' \
+               lib-python/2.7/test/test_subprocess.py || die
+       # requires Internet
+       sed -i -e '/class NetworkedTests/[email protected]("Requires 
networking")' \
+               lib-python/2.7/test/test_ssl.py || die
+
+       eapply_user
+}
+
+src_compile() {
+       # copy over to make sys.prefix happy
+       cp -p "${BROOT}"/usr/lib/pypy2.7/pypy-c-${PV} pypy-c || die
+       cp -p "${BROOT}"/usr/lib/pypy2.7/include/${PV}/* include/ || die
+       # (not installed by pypy)
+       rm pypy/module/cpyext/include/_numpypy/numpy/README || die
+       mv pypy/module/cpyext/include/* include/ || die
+       mv pypy/module/cpyext/parse/*.h include/ || die
+       pax-mark m pypy-c
+
+       einfo "Generating caches and CFFI modules ..."
+
+       # Generate Grammar and PatternGrammar pickles.
+       ./pypy-c -c "import lib2to3.pygram, lib2to3.patcomp; 
lib2to3.patcomp.PatternCompiler()" \
+               || die "Generation of Grammar and PatternGrammar pickles failed"
+
+       # Generate cffi modules
+       # Please keep in sync with pypy/tool/build_cffi_imports.py!
+#cffi_build_scripts = {
+#    "_ssl": "_ssl_build.py",
+#    "sqlite3": "_sqlite3_build.py",
+#    "audioop": "_audioop_build.py",
+#    "tk": "_tkinter/tklib_build.py",
+#    "curses": "_curses_build.py" if sys.platform != "win32" else None,
+#    "syslog": "_syslog_build.py" if sys.platform != "win32" else None,
+#    "gdbm": "_gdbm_build.py"  if sys.platform != "win32" else None,
+#    "pwdgrp": "_pwdgrp_build.py" if sys.platform != "win32" else None,
+#    "resource": "_resource_build.py" if sys.platform != "win32" else None,
+       cffi_targets=( ssl audioop syslog pwdgrp resource )
+       use gdbm && cffi_targets+=( gdbm )
+       use ncurses && cffi_targets+=( curses )
+       use sqlite && cffi_targets+=( sqlite3 )
+       use tk && cffi_targets+=( tkinter/tklib )
+
+       local t
+       # all modules except tkinter output to .
+       # tkinter outputs to the correct dir ...
+       cd lib_pypy || die
+       for t in "${cffi_targets[@]}"; do
+               # tkinter doesn't work via -m
+               ../pypy-c "_${t}_build.py" || die "Failed to build CFFI 
bindings for ${t}"
+       done
+
+       # Cleanup temporary objects
+       find -name "_cffi_*.[co]" -delete || die
+       find -type d -empty -delete || die
+}
+
+src_test() {
+       # (unset)
+       local -x PYTHONDONTWRITEBYTECODE=
+
+       local ignored_tests=(
+               # network
+               --ignore=lib-python/2.7/test/test_urllibnet.py
+               --ignore=lib-python/2.7/test/test_urllib2net.py
+               # lots of free space
+               --ignore=lib-python/2.7/test/test_zipfile64.py
+       )
+
+       ./pypy-c ./pypy/test_all.py --pypy=./pypy-c -vv \
+               "${ignored_tests[@]}" lib-python || die
+}
+
+src_install() {
+       local dest=/usr/lib/pypy2.7
+       einfo "Installing PyPy ..."
+       dosym pypy-c-${PV} "${dest}/pypy-c"
+       insinto "${dest}"
+       # preserve mtimes to avoid obsoleting caches
+       insopts -p
+       doins -r include lib_pypy lib-python
+
+       # replace copied headers with symlinks
+       for x in "${BROOT}"/usr/lib/pypy2.7/include/${PV}/*; do
+               dosym "${PV}/${x##*/}" "${dest}/include/${x##*/}"
+       done
+
+       dosym ../lib/pypy2.7/pypy-c /usr/bin/pypy
+       dodoc README.rst
+
+       if ! use gdbm; then
+               rm -r "${ED}${dest}"/lib_pypy/gdbm.py \
+                       "${ED}${dest}"/lib-python/*2.7/test/test_gdbm.py || die
+       fi
+       if ! use sqlite; then
+               rm -r "${ED}${dest}"/lib-python/*2.7/sqlite3 \
+                       "${ED}${dest}"/lib_pypy/_sqlite3.py \
+                       "${ED}${dest}"/lib-python/*2.7/test/test_sqlite.py || 
die
+       fi
+       if ! use tk; then
+               rm -r "${ED}${dest}"/lib-python/*2.7/{idlelib,lib-tk} \
+                       "${ED}${dest}"/lib_pypy/_tkinter \
+                       
"${ED}${dest}"/lib-python/*2.7/test/test_{tcl,tk,ttk*}.py || die
+       fi
+
+       local -x EPYTHON=pypy
+       local -x PYTHON=${ED}${dest}/pypy-c-${PV}
+       # temporarily copy to build tree to facilitate module builds
+       cp -p "${BROOT}${dest}/pypy-c-${PV}" "${PYTHON}" || die
+
+       echo "EPYTHON='${EPYTHON}'" > epython.py || die
+       python_moduleinto /usr/lib/pypy2.7/site-packages
+       python_domodule epython.py
+
+       einfo "Byte-compiling Python standard library..."
+       python_optimize "${ED}${dest}"
+
+       # remove to avoid collisions
+       rm "${PYTHON}" || die
+}

Reply via email to